cd /d "%~dp0"
path %path%;%~dp0\tdm64\bin

set IS32BIT_CC=
set IS32BIT_LIB=

if "%~n0" == "build64" goto skip32
set IS32BIT_CC=-m32
set IS32BIT_LIB=--machine=i386 -f--32

:skip32

echo LIBRARY obs.dll > libobs.def
echo EXPORTS >> libobs.def
echo obs_data_set_default_int >> libobs.def
echo blog >> libobs.def
echo bfree >> libobs.def
echo obs_properties_create >> libobs.def
echo obs_properties_add_int >> libobs.def
echo obs_properties_add_bool >> libobs.def
echo obs_data_get_int >> libobs.def
echo obs_data_get_bool >> libobs.def
echo obs_encoder_audio >> libobs.def
echo bmalloc >> libobs.def
echo audio_output_get_channels >> libobs.def
echo audio_output_get_sample_rate >> libobs.def
echo obs_register_encoder_s >> libobs.def
echo text_lookup_getstr >> libobs.def
echo text_lookup_destroy >> libobs.def
echo obs_module_load_locale >> libobs.def
echo obs_data_set_default_bool >> libobs.def

echo LIBRARY obs-libfdk.dll > obs-libfdk.def
echo EXPORTS >> obs-libfdk.def
echo obs_module_load >> obs-libfdk.def
echo obs_module_ver >> obs-libfdk.def
echo obs_module_set_pointer >> obs-libfdk.def

dlltool -Dobs.dll %IS32BIT_LIB% --input-def=libobs.def --output-lib=libobs.lib
dlltool -Dobs-libfdk.dll %IS32BIT_LIB% --input-def=obs-libfdk.def --output-exp=obs-libfdk.exp

cd fdk-aac-0.1.5
mingw32-make -f ..\make-fdk-aac.tdmgcc fdk-aac.lib
mkdir ..\fdkinc
mkdir ..\fdkinc\fdk-aac
for /f %%a in ('dir include /s /b /ad') do copy /y "%%~a\*" ..\fdkinc\fdk-aac
cd ..
cd obs-studio-21.0.1\plugins\obs-libfdk
gcc %IS32BIT_CC% -shared -oobs-libfdk.dll -O2 -I"../../libobs" -I"../../../fdkinc" "../../../obs-libfdk.exp" obs-libfdk.c "../../../fdk-aac-0.1.5/fdk-aac.lib" "../../../libobs.lib"
strip obs-libfdk.dll
move obs-libfdk.dll ../../../

pause